<template>
  <div>
    <AtomAlert
      v-if="error"
      class="fr-mx-4w"
      :alert-type="AlertType.Error"
      message="La liste des synthèses d'entretien n'a pas pu être chargée."
    />
    <template v-else>
      <BeneficiaryHistoryFilters
        class="fr-px-5v"
        :is-in-interviews-context="true"
        :is-in-help-requests-context="false"
        @filter="onFilter"
      />
      <hr />
      <p class="fr-mb-2w fr-mx-5v fr-hint-text">
        {{ interviewsCount }} synthèse(s) d'entretien
      </p>
      <AtomLoader
        v-show="pending"
        class="fr-mx-auto"
      />
      <div
        class="table-container fr-pb-0"
        tabindex="0"
      >
        <div
          v-show="!pending"
          class="fr-table fr-table--bordered fr-mb-0 fr-pt-0 fr-table--no-caption"
        >
          <table>
            <caption>
              Entretiens
            </caption>
            <thead>
              <tr>
                <th
                  id="status-col"
                  scope="col"
                >
                  Statut
                </th>
                <th scope="col">Type d'entretien</th>
                <th scope="col">Objet de l'entretien</th>
                <th scope="col">
                  Date d'échéance
                  <AtomSortButton @sort="onSort($event, 'due_date')" />
                </th>
                <th scope="col">
                  Bénéficiaire
                  <AtomSortButton
                    @sort="onSort($event, 'beneficiary.usual_name')"
                  />
                </th>
                <th scope="col">Agent</th>
                <th scope="col">N° de dossier</th>
              </tr>
            </thead>
            <tbody>
              <BeneficiaryHistoryRow
                v-for="interview in interviews"
                :key="interview.id"
                :history="interview"
                is-interview
                @updated="onInterviewUpdated"
              />
            </tbody>
          </table>
        </div>
      </div>
      <AtomPagination
        v-show="!pending"
        class="fr-mt-4w fr-px-5v"
        :page="page"
        :total="interviewsCount"
        @change-page="updatePagination($event)"
      />
    </template>
  </div>
</template>

<script setup>
  import { useFiltersStore } from '~/store/filters'
  import { REQUEST_LIMIT_DEFAULT } from '~/utils/constants'
  import { errorResponseMessage } from '~/utils/errorResponse'
  import { getRandomId } from '~~/utils/random'
  import { AlertType } from '~~/utils/constants/alert'
  import { INTERVIEWS_TABLE_FIELDS } from '~/utils/constants/interview'

  const DEFAULT_SORT = { field: 'date', sort: '-' }

  const { $getItems } = useNuxtApp()
  const filtersStore = useFiltersStore()

  const filters = ref(
    filtersStore.interviewHistory.directusQuery?.interviewFilters
  )
  const sorts = ref([DEFAULT_SORT])
  const page = ref(1)
  const limit = ref(REQUEST_LIMIT_DEFAULT)

  const {
    data: interviews,
    pending: interviewsPending,
    error: interviewsError,
    refresh: interviewsRefresh
  } = useLazyAsyncData(getRandomId('interviews'), loadInterviews, {
    server: false
  })

  const {
    data: interviewsCount,
    pending: interviewsCountPending,
    error: interviewsCountError,
    refresh: interviewsCountRefresh
  } = useLazyAsyncData(getRandomId('interviewsCount'), loadInterviewsCount, {
    server: false,
    default: () => 0
  })

  const pending = computed(
    () => interviewsPending.value || interviewsCountPending.value
  )

  const error = computed(
    () => interviewsError.value || interviewsCountError.value
  )

  async function loadInterviews() {
    const query = {
      fields: INTERVIEWS_TABLE_FIELDS,
      sort: sorts.value,
      limit: limit.value,
      page: page.value
    }
    if (filters.value) query.filter = filters.value
    const res = await $getItems('follow_ups', query)

    if (res.status === 200) return res.data.data
    throw new Error(errorResponseMessage(res))
  }

  // NOTE: It is not using `filter_count` meta in the query loading the items due to a Directus bug - See https://github.com/directus/directus/discussions/16992
  async function loadInterviewsCount() {
    const query = { aggregate: { countDistinct: 'id' } }
    if (filters.value) query.filter = filters.value
    const res = await $getItems('follow_ups', query)

    if (res.status === 200) return parseInt(res.data.data[0].countDistinct.id)
    throw new Error(errorResponseMessage(res))
  }

  function onFilter({ interviewFilters }) {
    filters.value = interviewFilters
    interviewsRefresh()
    interviewsCountRefresh()
  }

  function onSort(sortDir, field) {
    sorts.value = sorts.value.filter(s => s.field !== field)
    sorts.value.unshift({ field, sort: sortDir })
    interviewsRefresh()
  }

  function updatePagination({ pageNumber, limitValue }) {
    page.value = pageNumber
    limit.value = Number(limitValue)
    interviewsRefresh()
  }

  function onInterviewUpdated(interview) {
    interviews.value = interviews.value.map(i =>
      i.id === interview.id ? interview : i
    )
  }
</script>

<style lang="scss" scoped>
  .table-container {
    // 21.5rem seems to come up out of the box. It corresponds to the total height of elements existing above and under the table
    max-height: calc(100vh - 23.5rem);
  }
</style>
